'==========
'SNOWMAN.BAS v1.03
'===========
'Play Snowman animation while playing 17 Christmas songs.
'Coded by Dav for QB64PE, DEC/2022
'ALL MEDIA SOURCES FOUND IN PUBLIC DOMAIN
'
'=======================================================================
'NOTE: THIS PROGRAM REQUIRES QB64-PE v3.2 OR HIGHER TO RUN & USE MIDI
'=======================================================================
'
'CONTROLS:
'           WHILE PLAYING, USE LEFT & RIGHT ARROWS TO SKIP SONGS.
'           ANY OTHER KEY QUITS THE SAVER
'
'The screen saver will start playing a random song.  You an skip up/down
'to different songs using the left/right arrow keys.  Pressing any other
'key will quit the program.
'
'NOTE: It takes a minute or two to load all the MIDI files on startup.
'Please be patient while they load, and enjoythe Christmas screen saver.
'
'=======================================================================

$Unstable:Midi
Print "=============================="
Print "SNOWMAN SCREENSAVER FOR QB64PE"
Print "(please wait while files load)"
Print "=============================="
Print
Print "Init MIDI soundfont...";
$MidiSoundFont:Default
Print "OK!"

'=== Check the animation file
Print "Checking animation file...";
file$ = "snowman.dat"
Open file$ For Binary As #1
If LOF(1) = 0 Then
    Print "SNOWMAN.DAT NOT FOUND!"
    Close 1: Kill file$
    End
End If
If LOF(1) <> 800528 Then
    Print "INVALID SNOWMAN.DAT!"
    Close 1
    End
End If
Print "OK!"

'=== Build the MIDI song list..

trackmax = 17 '17 midi files
Dim song$(1 To trackmax), songhand&(1 To trackmax)
'name each one
song$(1) = "frosty.mid"
song$(2) = "hark.mid"
song$(3) = "away.mid"
song$(4) = "angels.mid"
song$(5) = "carol.mid"
song$(6) = "joy.mid"
song$(7) = "deck.mid"
song$(8) = "wethree.mid"
song$(9) = "holynite.mid"
song$(10) = "godrest.mid"
song$(11) = "itcame.mid"
song$(12) = "ohcome.mid"
song$(13) = "noel.mid"
song$(14) = "silent.mid"
song$(15) = "town.mid"
song$(16) = "jingle.mid"
song$(17) = "wewish.mid"

For s = 1 To trackmax
    Print "Loading MIDI file"; s; "of"; trackmax; ": "; song$(s); "...";
    songhand&(s) = _SndOpen(song$(s), "stream")
    If songhand&(s) = 0 Then
        Print "Error opening file: "; song$(s)
        End
    End If
    Print "OK!"
Next

'=== start playing a random track
Randomize Timer
track = Int(Rnd * trackmax) + 1
_SndPlay songhand&(track)


Screen 13: _FullScreen _SquarePixels , _Smooth

Do
    Seek 1, 129
    For f% = 1 To 15
        FF& = Seek(1): FRM$ = Input$(16, 1)
        FrameSize& = CVL(Mid$(FRM$, 1, 4))
        chunks% = CVI(Mid$(FRM$, 7, 2))
        d$ = InKey$
        If d$ <> "" Then
            Select Case d$
                Case Chr$(0) + Chr$(77)
                    _SndStop songhand&(track)
                    track = track + 1
                    If track > trackmax Then track = 1
                    _SndPlay songhand&(track)
                Case Chr$(0) + Chr$(75)
                    _SndStop songhand&(track)
                    track = track - 1
                    If track < 1 Then track = trackmax
                    _SndPlay songhand&(track)
                Case Else: Exit Do
            End Select
        End If
        For C% = 1 To chunks%
            Fpos& = Seek(1)
            CD$ = Input$(6, 1)
            ChunkSize& = CVL(Mid$(CD$, 1, 4))
            ChunkType% = CVI(Mid$(CD$, 5, 2))
            Fpos& = Fpos& + ChunkSize&
            Select Case ChunkType%
                Case 11
                    Clr% = 0
                    paks% = Asc(Input$(2, 1))
                    For d% = 1 To paks%
                        skip% = Asc(Input$(1, 1))
                        change% = Asc(Input$(1, 1))
                        If change% = 0 Then change% = 256
                        Clr% = Clr% + skip%
                        For s% = 1 To change%
                            Out &H3C8, Clr%
                            Out &H3C9, Asc(Input$(1, 1))
                            Out &H3C9, Asc(Input$(1, 1))
                            Out &H3C9, Asc(Input$(1, 1))
                            Clr% = Clr% + 1
                        Next
                    Next
                Case 12
                    skip% = CVI(Input$(2, 1))
                    change% = CVI(Input$(2, 1))
                    For y% = skip% To change% + (skip% - 1)
                        ppos& = Seek(1)
                        C$ = Input$(500, 1): m% = 1
                        paks% = Asc(Mid$(C$, m%, 1)): m% = m% + 1: x% = 0
                        For d% = 1 To paks%
                            s% = Asc(Mid$(C$, m%, 1))
                            p% = Asc(Mid$(C$, m% + 1, 1))
                            m% = m% + 2: x% = x% + s%
                            If p% > 127 Then
                                p% = (256 - p%)
                                Line (x%, y%)-Step(p% - 1, 0), Asc(Mid$(C$, m%, 1))
                                x% = x% + p%: m% = m% + 1
                            Else
                                Row$ = Mid$(C$, m%, p%)
                                m% = m% + p%
                                For g% = 0 To p% - 1
                                    PSet (x% + g%, y%), Asc(Mid$(Row$, g% + 1, 1))
                                Next
                                x% = x% + p%
                            End If
                        Next
                        Seek #1, ppos& + m% - 1: C$ = ""
                    Next
                Case 16
                    x% = 0
                    For y% = 0 To 199
                        Row$ = Input$(320, 1): p% = 320
                        For g% = 0 To p% - 1
                            PSet (x% + g%, y%), Asc(Mid$(Row$, g% + 1, 1))
                        Next
                    Next
                Case Else: Close 1: Exit Do
            End Select
            Seek #1, Fpos&
        Next
        Seek 1, FF& + FrameSize&
        _Display
        _Limit 12
    Next

    If Not _SndPlaying(songhand&(track)) Then
        _SndStop songhand&(track)
        track = track + 1
        If track > trackmax Then track = 1
        _SndPlay songhand&(track)
    End If

Loop

_SndStop songhand&(track)
_SndClose songhand&(track)

Close 1
System

